-- HivemindLastPart - Released during BFA

local HivemindLastPart = ...

HivemindLastPart = LibStub("AceAddon-3.0"):NewAddon("HivemindLastPart", "AceConsole-3.0", "AceEvent-3.0")

local optionsFrame = ""
local fNextPlates = "|cFF00FF00 1 Player 1 = Forward - Forward|r\n"
					.."|cFF00FF00 2 Player 2 = Forward - Left - Forward|r\n"
					.."|cFF00FF00 3 Player 1 = Forward|r\n"
					.."|cFF00FF00 4 Player 3 = Forward - Forward - Right -Right|r\n"
					.."|cFF00FF00 5 Player 4 = Forward - Left|r\n"
					.."|cFF00FF00 6 Player 5 = Forward|r\n"
					.."|cFF00FF00 7 Player 2 = Left|r\n"
					.."|cFF00FF00 8 Player 4 = Forward|r\n"
					.."|cFF00FF00 9 Player 2 = Left|r\n"
					.."|cFF00FF00 10 Player 4 = Left - Forward|r\n"
					.."|cFF00FF00 11 Player 2 = Forward - Left|r\n"
					.."|cFF00FF00 12 Player 3 = Backward|r\n"
					.."|cFF00FF00 13 Player 5 = Forward - Right - Right - Right|r\n"
					.."|cFF00FF00 14 Player 3 = Forward|r\n"
					.."|cFF00FF00 15 Player 5 = Forward|r\n"
					.."|cFF00FF00 16 Player 1 = Right - Forward|r\n"
					.."|cFF00FF00 17 Player 3 = Backward - Forward - Right|r\n"
					.."|cFF00FF00 18 Player 1 = Forward - Left|r\n"
					.."|cFF00FF00 19 Player 4 = Forward|r\n"
					.."|cFF00FF00 20 Player 2 = Backward - Forward|r\n"
					.."|cFF00FF00 21 Player 5 = Forward|r\n"
					.."|cFF00FF00 22 Player 2 = Backward - Forward|r\n"
					.."|cFF00FF00 23 Player 5 = Right|r\n"
					.."|cFF00FF00 24 Player 3 = Forward|r\n"
					.."|cFF00FF00 25 Player 1 = Forward - Right|r\n"
					.."|cFF00FF00 26 Player 2 = Forward - Right|r\n"
					.."|cFF00FF00 27 Player 4 = Forward|r\n"
					.."|cFF00FF00 28 Player 1 = Right - Forward|r\n"
					.."|cFF00FF00 29 Player 3 = Left|r\n"
					.."|cFF00FF00 30 Player 4 = Forward|r\n"
					.."|cFF00FF00 31 Player 3 = Forward - Forward|r\n"
					.."|cFF00FF00 32 Player 5 = Forward|r\n"
					.."|cFF00FF00 33 Player 1 = Left|r\n"
					.."|cFF00FF00 34 Player 4 = Right|r\n"
					.."|cFF00FF00 35 Player 5 = Left|r\n"
					.."|cFF00FF00 36 Player 2 = Forward|r\n"
					.."|cFF00FF00 37 Player 4 = Forward|r\n"
					.."|cFF00FF00 38 Player 5 = Forward - Forward|r\n"
					.."|cFF00FF00 39 Player 1 = Forward|r\n"
					.."|cFF00FF00 40 Player 3 = Left|r\n"
					.."|cFF00FF00 41 Player 5 = Right - Forward|r\n"
					.."|cFF00FF00 42 Player 4 = Forward|r\n"
					.."|cFF00FF00 43 Player 1 = Right|r\n"
					.."|cFF00FF00 44 Player 5 = Left|r\n"
					.."|cFF00FF00 45 Player 1 = Forward|r\n"
					.."|cFF00FF00 46 Player 2 = Forward|r\n"
					.."|cFF00FF00 47 Player 3 = Jump off! (leave vehicle, only this person!).|r\n"
					.."|cFF00FF00 48 Player 3 = Jump on the left-most disk|r\n"
					.."|cFF00FF00 49 Player 3 = Forward|r\n"
					.."|cFF00FF00 50 Player 2 = Forward|r\n"
					.."|cFF00FF00 51 Player 3 = Forward - Forward - Forward|r\n"
					.."|cFF00FF00 52 Player 2 = Backward|r\n"
					.."|cFF00FF00 53 Player 4 = Right|r\n"
					.."|cFF00FF00 54 Player 5 = Forward|r\n"
					.."|cFF00FF00 55 Player 2 = Forward - Right - Forward|r\n"
					.."|cFF00FF00 56 Player 3 = Forward - Forward - Forward - Forward|r\n"
					.."|cFF00FF00 57 All Player = Leave vehicule (Complete)|r\n"
					
HivemindLastPart.fKillsLocations = {
	[0] = "/way Suramar 71.8, 62.5 Rikei",
	[1] = "/way Suramar 46.8, 28.6 Blom'an",
	[2] = "/way Suramar 19.9, 46.3 Giluzui",
	[3] = "/way Suramar 43.5, 81.8 Yorilan",
	[4] = "/way Suramar 41.0 69.5 Blocked Drawer",
	[5] = "/way Suramar 50.7, 65.5 Court of Stars entrance",
}

local MyMinimap = {
        type = "launcher",
        text = "HivemindLastPart",
        icon = "Interface\\Addons\\HivemindPlates\\Icons\\Hivemind",
        OnClick = function( f, button )
                    --if button == "RightButton" then 
                      LibStub("AceConfigDialog-3.0"):Open("HivemindLastPart")
                    --end
                    GameTooltip:Hide()
                  end,
        OnTooltipShow = function( mt )
                          mt:AddDoubleLine( "HivemindLastPart", Minimap.text )
                          mt:AddLine( "|cFFFFFFFFClick to open the the HivemindLastPart interface.|r" )
                        end,
} 

function HivemindLastPart:GetOptions()
  local options = {
    name = "HivemindLastPart",
    handler = HivemindLastPart,
    type = 'group',
    args = {
	    intro = {
		    order = 1,
			  type = "description",
			  name = "Jumping Puzzle Sequences / Suramar Beams and part of lost cat toy.",
		  },
      qf = {
        order = 2,
        type = "input",
        name = "Jumping puzzle Sequence",
        desc = "A list of Sequence",
        usage = "Follow the sequence to complete the Jumping puzzle.",
        get = "GetNextPlates",
        width = "full",
        multiline = 15,
      },
	  ds = {
        order = 3,
        type = "description",
        name = "Suramar Beams and part of lost cat toy",
      },
	  sr = {
        order = 4,
        type = "execute",
        name = "Set TomTom Coordinate",
        desc = "Set TomTom Waypoints Coordinate to Rikei, Blom'an, Giluzui, Yorilan and Blocked Drawer entrance.",
        func = "SetWay",
      },
	  st = {
        order = 4,
        type = "execute",
        name = "Say Target Health",
        desc = "Tell to the party your current target health.",
        func = "SayTarHealth",
      },
	  rw = {
		order = 5,
        type = "execute",
        name = "Clear Coordinates",
		desc = "Remove all waypoints coordinate from the map.",
		func = 'ResetWay',
      },
	  de = {
        order = 6,
        type = "description",
        name = "Court of Stars entrance.",
      },
	  du = {
		order = 7,
        type = "execute",
        name = "Set Entrance Coordinate",
		desc = "Set Court of Stars entrance waypoints coordinate on the map.",
		func = 'CourtEntrance',
      },
	  mm = {
		order = 8,
        type = "toggle",
        name = "Hide Minimap Icon",
        desc = "If checked, the minimap icon will be hidden.",
        get = 'GetOption',
        set = 'SetOption',
      },
    },
  }
  return options
end
  
function HivemindLastPart:SetOption( info, input)
    self.DB.profile.minimap.hide = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLastPart", self.DB.profile.minimap )
end
  
function HivemindLastPart:GetOption( info)
    return self.DB.profile.minimap.hide            
end

function HivemindLastPart:ClearVars(info)
    fNextPlates = ""
end

function HivemindLastPart:CourtEntrance()
	RunSlashCmd(self.fKillsLocations[5])
	print("Waypoint Added! Check your map at Suramar:Broken Isles.")
end

function HivemindLastPart:ResetWay()
	RunSlashCmd("/way reset all")
end

function HivemindLastPart:SayTarHealth()
    local maxHealth =  UnitHealthMax("target")
	local health = UnitHealth("target")
	local nameTarget = UnitName("target")
	if nameTarget ~= nil then
		if IsEquippedItem(27944) then
			local total = (health / maxHealth * 100)
			SendChatMessage(nameTarget.." = "..tostring(round(total, 2)).."%", "PARTY", nil, nil)
		end
	end
end

function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function RunSlashCmd(cmd)
	local slash, rest = cmd:match("^(%S+)%s*(.-)$")
	ChatFrame_ImportAllListsToHash()
	local handler = hash_SlashCmdList[slash:upper()]
	if handler then
		handler(rest)
	end
end

function HivemindLastPart:SetWay()
    RunSlashCmd(self.fKillsLocations[0])
	RunSlashCmd(self.fKillsLocations[1])
	RunSlashCmd(self.fKillsLocations[2])
	RunSlashCmd(self.fKillsLocations[3])
	RunSlashCmd(self.fKillsLocations[4])
	print("Waypoint Added! Check your map at Broken Isles.")
end

function HivemindLastPart:GetDefaults()
  local defaults = {
    profile = {
      minimap = { 
        hide = true,
      }
    },
  }  
  return defaults
end

-- Not using 
function HivemindLastPart:TotalRefresh()
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLastPart", self.DB.profile.minimap )    
end

function HivemindLastPart:OnInitialize()
    -- Called when the addon is loaded
    self.DB = LibStub( "AceDB-3.0" ):New( "HivemindLastPartDB", self:GetDefaults() )

    self.Options = HivemindLastPart:GetOptions()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HivemindLastPart", self.Options, {"hlp"})
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("HivemindLastPart", 420, 460)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HivemindLastPart", "HivemindLastPart")
    self:RegisterChatCommand("hlp", function() LibStub("AceConfigDialog-3.0"):Open("HivemindLastPart") end)
    
    LibStub("LibDataBroker-1.1"):NewDataObject("HivemindLastPart", MyMinimap);
    LibStub("LibDBIcon-1.0"):Register("HivemindLastPart", MyMinimap, self.DB);
end

function HivemindLastPart:ChatCommand(input)
   if not input or input:trim() == "" then
       InterfaceOptionsFrame_OpenToCategory(optionsFrame)
   else     
        LibStub("AceConfigCmd-3.0"):HandleCommand("hlp", input)
   end
end

function HivemindLastPart:OnEnable()
    -- Called when the addon is enabled
    if self.DB.profile.minimap.hide == true then
      self:Print("HivemindLastPart enabled.  Minimap Icon is hidden.")
    else
      self:Print("HivemindLastPart enabled.  Minimap Icon is shown.")
    end
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLastPart", self.DB.profile.minimap )
end

function HivemindLastPart:OnDisable()
    -- Called when the addon is disabled
    self:Print("HivemindLastPart disabled.")
end

function HivemindLastPart:GetNextPlates(info)
	return fNextPlates
end

function HivemindLastPart:SetNextPlates(info, newValue)
    fNextPlates = ""
end

function HivemindLastPart:COMBAT_LOG_EVENT_UNFILTERED()
	local _,event, _,_,sourceName, _,_,_,destName, _,_,spellId = CombatLogGetCurrentEventInfo()
    if (event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE" or event == "SWING_DAMAGE") then
		local health = UnitHealth("target")
		local nameTarget = UnitName("target")
		if (nameTarget == "Rikei" or nameTarget == "Blom'an" or nameTarget == "Giluzui" or nameTarget == "Yorilan") then
			if IsEquippedItem(27944) then
				if health < 1000 then 
					SendChatMessage(nameTarget.." Is Dead!", "PARTY", nil, nil)
				end
			end
		end
	end
end

C_Timer.After(3, function() DEFAULT_CHAT_FRAME:AddMessage("|cff0083e8<HivemindLastPart loaded!>|cffffff3aType /hlp to open addon!|r") end)